wPortalsDB = {
	autoRestock = false,
	tele = 20,
	port = 20,
	powder = 100
}

local backdrop = {
	bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
	edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
	edgeSize = 16,
	insets = {left = 4, right = 4, top = 4, bottom = 4,}
}
local _, class = UnitClass("player")
if (class~="MAGE") then
	DisableAddOn("wPortals")
	print("|cffe1a500w|cff69ccf0Portals|cffffff00 has been disabled for this character since it's not a mage.")
end
local faction, _ = UnitFactionGroup("player")
local teleRunes, portRunes, arcanePowder = 0,0,0
local Locs = {
	Alliance = {
		{88342, 88345}, -- Tol Barad
		{53140, 53142}, -- Dalaran
		{33690, 33691}, -- Shattrath
		{3561, 10059}, -- Stormwind
		{3562, 11416}, -- Ironforge
		{3565, 11419}, -- Darnassus
		{32271, 32266}, -- Exodar
		{49359, 49360} -- Theramore
	},
	Horde = {
		{88344, 88346}, -- Tol Barad
		{53140, 53142}, -- Dalaran
		{35715, 35717}, -- Shattrath
		{3567, 11417}, -- Orgrimmar
		{3563, 11418}, -- Undercity
		{3566, 11420}, -- Thunder Bluff
		{32272, 32267}, -- Silvermoon
		{49358, 49361} -- Stonard
	},
}

local main = CreateFrame("Frame", "wPortalsMainFrame", UIParent)

local teleButtons = {}
local portButtons = {}
for i = 1,8 do
	local f = CreateFrame("Button",nil,main,"SecureActionButtonTemplate")
	f:SetSize(25,25)
	local g = CreateFrame("Button",nil,main,"SecureActionButtonTemplate")
	g:SetSize(25,25)
	if (i==1) then
		f:SetPoint("TOPLEFT",main,10,-10)
		g:SetPoint("TOP",f,"BOTTOM",0,-10)
	else
		f:SetPoint("LEFT",teleButtons[i-1],"RIGHT",5,0)
		g:SetPoint("LEFT",portButtons[i-1],"RIGHT",5,0)
	end
	table.insert(teleButtons,f)
	table.insert(portButtons,g)
end

local function teleUpdate()
	for i = 1,8 do
		local name, rank, icon, powerCost, isFunnel, powerType, castingTime, minRange, maxRange = GetSpellInfo(Locs[faction][i][1])
		teleButtons[i]:SetNormalTexture(icon)
		if (IsSpellKnown(Locs[faction][i][1])==true) then
			teleButtons[i]:SetAttribute("type1", "spell")
			teleButtons[i]:SetAttribute("spell", Locs[faction][i][1])
			teleButtons[i]:Enable(true)
			teleButtons[i]:SetScript("OnEnter", function(self) GameTooltip:SetOwner(self, "ANCHOR_TOPLEFT"); GameTooltip:ClearLines(); GameTooltip:AddLine(name); GameTooltip:Show() end)
		else
			teleButtons[i]:Enable(false)
			teleButtons[i]:SetScript("OnEnter", function(self) GameTooltip:SetOwner(self, "ANCHOR_TOPLEFT"); GameTooltip:ClearLines(); GameTooltip:AddLine(name); GameTooltip:AddLine("You do not know this spell yet!",1,0,0,1) GameTooltip:Show() end)
		end
		teleButtons[i]:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	end
end
local function portUpdate()
	for i = 1,8 do
		local name, rank, icon, powerCost, isFunnel, powerType, castingTime, minRange, maxRange = GetSpellInfo(Locs[faction][i][2])
		portButtons[i]:SetNormalTexture(icon)
		if (IsSpellKnown(Locs[faction][i][2])==true) then
			portButtons[i]:SetAttribute("type1", "spell")
			portButtons[i]:SetAttribute("spell", Locs[faction][i][2])
			portButtons[i]:Enable(true)
			portButtons[i]:SetScript("OnEnter", function(self) GameTooltip:SetOwner(self, "ANCHOR_TOPLEFT"); GameTooltip:ClearLines(); GameTooltip:AddLine(name); GameTooltip:Show() end)
		else
			portButtons[i]:Enable(false)
			portButtons[i]:SetScript("OnEnter", function(self) GameTooltip:SetOwner(self, "ANCHOR_TOPLEFT"); GameTooltip:ClearLines(); GameTooltip:AddLine(name); GameTooltip:AddLine("You do not know this spell yet!",1,0,0,1) GameTooltip:Show() end)
		end
		portButtons[i]:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	end
end

local function editBoxHandler(self, var)
	self:ClearFocus()
	if (type(tonumber(self:GetText()))~="number") or (tonumber(self:GetText())<0) then
		print("wPortals: Please enter a positive number.")
		self:SetText(wPortalsDB[var])
	else
		wPortalsDB[var] = tonumber(self:GetText())
	end
end

main:SetBackdrop(backdrop)
main:SetBackdropColor(0,0,0,0.9)
main:SetSize(260,115)
main:SetPoint("CENTER",UIParent)
main:EnableMouse(true)
main:SetMovable(true)
main:SetUserPlaced(true)
main:SetScript("OnMouseDown", function(self, button) if button=="LeftButton" then self:StartMoving() end end)
main:SetScript("OnMouseUp", function(self) self:StopMovingOrSizing() end)
main:Hide()
local options = CreateFrame("Frame","wPortalsOptions",main)
options:SetBackdrop(backdrop)
options:SetBackdropColor(0,0,0,0.9)
options:SetSize(150,115)
options:SetPoint("LEFT",main,"RIGHT")
options:Hide()
local restockCheck = CreateFrame("CheckButton",nil,options,"UICheckButtonTemplate")
restockCheck:SetSize(15,15)
restockCheck:SetPoint("TOPLEFT",options,10,-10)
restockCheck:SetScript("OnClick", function(self) if (wPortalsDB.autoRestock==false) then wPortalsDB.autoRestock = true else wPortalsDB.autoRestock = false end end)
local restockText = options:CreateFontString(nil,"OVERLAY","ChatFontSmall")
restockText:SetPoint("LEFT",restockCheck,"RIGHT")
restockText:SetText("Auto restock")
local trt = options:CreateFontString(nil,"OVERLAY","ChatFontSmall")
trt:SetPoint("TOPLEFT",options,10,-30)
trt:SetText("Teleport Runes:")
local tre = CreateFrame("EditBox",nil,options)
tre:SetSize(50,10)
tre:SetPoint("LEFT",trt,"RIGHT",3,0)
tre:IsMultiLine(false)
tre:SetAutoFocus(false)
tre:SetText(5)
tre:SetFontObject("GameFontNormalSmall")
tre:SetMaxBytes(4)
tre:SetScript("OnEnterPressed",function(self)
	editBoxHandler(self, "tele")
end)
local prt = options:CreateFontString(nil,"OVERLAY","ChatFontSmall")
prt:SetPoint("TOPLEFT",trt,0,-17)
prt:SetText("Portal Runes:")
local pre = CreateFrame("EditBox",nil,options)
pre:SetSize(50,10)
pre:SetPoint("LEFT",prt,"RIGHT",3,0)
pre:IsMultiLine(false)
pre:SetAutoFocus(false)
pre:SetText(5)
pre:SetFontObject("GameFontNormalSmall")
pre:SetMaxBytes(4)
pre:SetScript("OnEnterPressed",function(self)
	editBoxHandler(self, "port")
end)
local apt = options:CreateFontString(nil,"OVERLAY","ChatFontSmall")
apt:SetPoint("TOPLEFT",prt,0,-17)
apt:SetText("Arcane Powder:")
local ape = CreateFrame("EditBox",nil,options)
ape:SetSize(50,10)
ape:SetPoint("LEFT",apt,"RIGHT",3,0)
ape:IsMultiLine(false)
ape:SetAutoFocus(false)
ape:SetText(5)
ape:SetFontObject("GameFontNormalSmall")
ape:SetMaxBytes(4)
ape:SetScript("OnEnterPressed",function(self)
	editBoxHandler(self, "powder")
end)
local help = CreateFrame("Button",nil,options)
help:SetSize(10,10)
help:SetPoint("BOTTOMRIGHT",options,-10,10)
help:SetNormalTexture("interface\\raidframe\\readycheck-waiting")
help:GetNormalTexture():SetTexCoord(0,1,0,1)
help:SetScript("OnEnter",function(self) GameTooltip:SetOwner(self,"ANCHOR_TOPLEFT") GameTooltip:ClearLines() 
	GameTooltip:AddLine("wPortals 'Auto restock'\n \n'Auto Restock' will resupply your\nreagents listed above to your desired\namount whenever you visit a reagent\nvendor.")
	GameTooltip:Show()
end)
help:SetScript("OnLeave",function(self) GameTooltip:Hide() end)

local function createTracker(name,tex,tooltip,anch)
	local f = CreateFrame("Button",(name.."Tracker"),main)
	f:SetSize(25,25)
	f:SetNormalTexture(tex)
	f:SetScript("OnEnter",function(self) GameTooltip:SetOwner(self,"ANCHOR_TOPLEFT") GameTooltip:ClearLines() GameTooltip:AddLine(tooltip) GameTooltip:Show() end)
	f:SetScript("OnLeave",function(self) GameTooltip:Hide() end)
	f:SetPoint(anch[1],anch[2],anch[3],anch[4],anch[5])
	local g = f:CreateFontString((name.."Text"),"OVERLAY","ChatFontSmall")
	g:SetPoint("BOTTOMRIGHT",f,-2,2)
	g:SetFont("fonts\\frizqt__.ttf",11,"OUTLINE")
	return f, g
end
local teleRuneIcon, teleRuneText = createTracker("teleRune","interface\\icons\\inv_misc_rune_06","Rune of Teleportation",{"BOTTOMLEFT",main,"BOTTOMLEFT",10,10})
local portRuneIcon, portRuneText = createTracker("portRune","interface\\icons\\inv_misc_rune_08","Rune of Portals",{"LEFT",teleRuneIcon,"RIGHT",5,0})
local powderIcon, powderText = createTracker("powder","interface\\icons\\inv_misc_dust_01","Arcane Powder",{"LEFT",portRuneIcon,"RIGHT",5,0})

options:SetScript("OnShow",function(self)
	restockCheck:SetChecked(wPortalsDB.autoRestock)
	tre:SetText(wPortalsDB.tele)
	pre:SetText(wPortalsDB.port)
	ape:SetText(wPortalsDB.powder)
end)
main:SetScript("OnShow", function(self)
	faction, _ = UnitFactionGroup("player")
	teleRunes = GetItemCount(17031,true)
	portRunes = GetItemCount(17032,true)
	arcanePowder = GetItemCount(17020,true)
	teleRuneText:SetFormattedText("|cff69CCF0%d",teleRunes)
	portRuneText:SetFormattedText("|cff69CCF0%d",portRunes)
	powderText:SetFormattedText("|cff69ccf0%d",arcanePowder)
	teleUpdate()
	portUpdate()
end)
local closeButton = CreateFrame("Button",nil, main,"OptionsButtonTemplate")
closeButton:SetPoint("BOTTOMRIGHT", main, "BOTTOMRIGHT", -10, 10)
closeButton:SetScript("OnClick", function(self) main:Hide() options:Hide() end)
closeButton:SetSize(60,20)
closeButton:SetText("Close")
local optionsButton = CreateFrame("Button",nil,main,"OptionsButtonTemplate")
optionsButton:SetPoint("RIGHT",closeButton,"LEFT",-5,0)
optionsButton:SetSize(60,20)
optionsButton:SetText("Options")
optionsButton:SetScript("OnClick",function(self) if (options:IsShown()) then options:Hide() else options:Show() end end)

SLASH_WPORTALS1 = '/port'
SLASH_WPORTALS2 = '/ports'
SLASH_WPORTALS3 = '/wport'
SLASH_WPORTALS4 = '/wportals'
function SlashCmdList.WPORTALS(msg,editbox)
	main:Show()
end

local buyTeleRunes, buyPortRunes, buyArcanePowder
local event = CreateFrame("Frame")
event:SetScript("OnEvent", function(self,event,arg1,arg2,arg3,arg4)
	if (wPortalsDB.autoRestock==true) and (class=="MAGE") then
		totalItems = GetMerchantNumItems()
		teleRunes = GetItemCount(17031,true)
		portRunes = GetItemCount(17032,true)
		arcanePowder = GetItemCount(17020,true)
		for j = 1,totalItems do
			local name, texture, price, quantity, numAvail, usable, extCost = GetMerchantItemInfo(j)
			if (name=="Rune of Teleportation") then
				if (teleRunes < wPortalsDB.tele) then
					buyTeleRunes = (wPortalsDB.tele - teleRunes)
					BuyMerchantItem(j, buyTeleRunes)
				end
			end
			if (name=="Rune of Portals") then
				if (portRunes < wPortalsDB.port) then
					buyPortRunes = (wPortalsDB.port - portRunes)
					BuyMerchantItem(j, buyPortRunes)
				end
			end
			if (name=="Arcane Powder") then
				if (arcanePowder < wPortalsDB.powder) then
					buyArcanePowder = (wPortalsDB.powder - arcanePowder)
					BuyMerchantItem(j, buyArcanePowder)
				end
			end
		end
	end
end)
event:RegisterEvent("MERCHANT_SHOW")

wPortalsBroker = LibStub("LibDataBroker-1.1"):NewDataObject("Broker_wPortals", {
	type = "launcher",
	icon = "Interface\\Icons\\Spell_Arcane_PortalDalaran",
	label = "wPortals",
	OnClick = function(_, button)
		if button == "LeftButton" then
			main:Show()
		end
	end,
	OnTooltipShow = function(tooltip)
		tooltip:AddLine("|cffe1a500w|cff69ccf0Portals")
		tooltip:AddLine("|cff69ccf0Left Click|cffffd200 to show the portals frame.")
	end,
})
